﻿(function(){

//ドキュメント確認
if(app.documents.length==0){
alert("InDesignドキュメントを開いてから実行してください。");
exit() ;
}else if(app.documents.length>1){
	alert("複数のInDesignドキュメントを開いている場合、最前面ドキュメントのみが処理対象となります。");
	}
if(app.documents[0].saved==false){
		alert("処理対象のInDesignドキュメントを保存してから実行してください。");
		exit() ;
}
alert("検索してリストを作成します。")


//外部テキストファイルを用意
now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime="-"+myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;
saveFolderPath = app.documents[0].filePath; // ドキュメントの保存フォルダ
fileObj = new File(saveFolderPath +"/【"+app.documents[0].name+"】検索リスト"+ nowTime+".txt");
fileObj.encoding="UTF8";

///一覧を生成
var doc = app.documents[0] ;
var ngList=new String;
ngList=("　【検索内容】\t【ページ】\r");

//検索オプションGrep
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか

//圏点（カスタム）を指定
app.findGrepPreferences.kentenKind=KentenCharacter.CUSTOM;
app.findGrepPreferences.kentenCustomCharacter="〓";
app.findGrepPreferences.findWhat=""

var gr=doc.findGrep(); // 検索だけ
var grl=gr.length; 


for (i=0; i<grl; i++) { 
	ngList=(ngList+"\r"+gr[i].contents+"\t"+gr[i].parentTextFrames[0].parentPage.name);
}

ngList=ngList.replace(/[\u0007\u0003\u200C\n]/g,""); //「ここまでインデント」文字、先頭文字スタイルの終了文字、結合なし、強制改行を削除
ngList=ngList.replace(/([^\d])\r/g, "$1");
ngList=ngList.replace(/([^\d\t]\d+)\r/g, "$1");
ngList=ngList.replace(/\r[\t 　]+/g, "\r");

flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();
}else{
alert("ファイルが作成できません。アクセス権があるか確認してください");
}

})();